import { AxiosError, AxiosRequestConfig, AxiosResponse } from 'axios';
import { Options } from './options';
import { IStringifyOptions } from 'qs';
export declare class Endpoint {
    protected localOptions?: Options;
    setLocalOptions(options: Options | undefined): this;
    get options(): Options;
    get config(): AxiosRequestConfig;
    get origin(): string;
    get path(): string;
    get resource(): string;
    get baseURL(): string;
    get stringifyOptions(): IStringifyOptions;
    get paramsSerializer(): (params: any) => string;
    requestConfig(requestConfig: AxiosRequestConfig): AxiosRequestConfig;
    request<T = any, R = AxiosResponse<T>>(requestConfig: AxiosRequestConfig): Promise<R>;
    handleError<T = any, R = AxiosResponse<T>>(error: AxiosError<T>): Promise<R | never>;
}
//# sourceMappingURL=endpoint.d.ts.map