"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResourceEndpoint = void 0;
const crud_1 = require("./crud");
class ResourceEndpoint extends crud_1.CrudEndpoint {
    // Display a listing of the resource.
    index(params, cancelToken) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.get('/', { params, cancelToken });
        });
    }
    // Store a newly created resource in storage.
    store(data, params) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.post('/', { data, params });
        });
    }
    // Display the specified resource.
    show(id, params, cancelToken) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.get(`/${id}`, { params, cancelToken });
        });
    }
    // Update the specified resource in storage.
    update(id, data, params) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.put(`/${id}`, { data, params });
        });
    }
    // Store or update specified resource in storage.
    storeOrUpdate(id, data, params) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!id) {
                return this.store(data, params);
            }
            return this.update(id, data, params);
        });
    }
    // Remove the specified resource from storage.
    destroy(id, params) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.delete(`/${id}`, { params });
        });
    }
}
exports.ResourceEndpoint = ResourceEndpoint;
//# sourceMappingURL=resource.js.map