"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMessage = exports.hasMessage = exports.getStatus = exports.getErrors = exports.getFallbackMessage = void 0;
const getFallbackMessage = (response, defaultMessage) => {
    var _a;
    return typeof ((_a = response === null || response === void 0 ? void 0 : response.data) === null || _a === void 0 ? void 0 : _a.message) === 'string'
        ? response.data.message
        : defaultMessage !== null && defaultMessage !== void 0 ? defaultMessage : 'An unexpected error has occurred. Please try again.';
};
exports.getFallbackMessage = getFallbackMessage;
const getErrors = (response) => {
    var _a;
    return (_a = response === null || response === void 0 ? void 0 : response.data) === null || _a === void 0 ? void 0 : _a.errors;
};
exports.getErrors = getErrors;
const getStatus = (response) => {
    return (response === null || response === void 0 ? void 0 : response.status) ? response.status : 500;
};
exports.getStatus = getStatus;
const hasMessage = (key, response) => {
    const errors = (0, exports.getErrors)(response);
    return !!errors && typeof errors[key] !== 'undefined';
};
exports.hasMessage = hasMessage;
const getMessage = (key, response, defaultMessage) => {
    var _a;
    const errors = (0, exports.getErrors)(response);
    return (_a = errors === null || errors === void 0 ? void 0 : errors[key]) !== null && _a !== void 0 ? _a : (0, exports.getFallbackMessage)(response, defaultMessage);
};
exports.getMessage = getMessage;
//# sourceMappingURL=messages.js.map