"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApiMixin = void 0;
const url_join_1 = __importDefault(require("url-join"));
// eslint-disable-next-line @typescript-eslint/explicit-function-return-type
function ApiMixin(superClass) {
    return class extends superClass {
        // Override to set as version, default to empty
        // e.g. v1, v3, v5 and so on.
        get version() {
            return '';
        }
        // This it the middle of the url path, usually a group prefix.
        // e.g. api/v1 or user/settings
        get path() {
            return (0, url_join_1.default)(super.path, this.version);
        }
    };
}
exports.ApiMixin = ApiMixin;
//# sourceMappingURL=api.js.map