import { AxiosResponse } from 'axios';
import { Constructor } from './types';
export declare function AuthMixin<T extends Constructor<any>>(superClass: T): {
    new (...args: any[]): {
        [x: string]: any;
        login<T_1 = any, R = AxiosResponse<T_1, any>>(values: {
            email: string;
            password: any;
            remember?: boolean;
        }): Promise<R>;
        logout<T_2 = any, R_1 = AxiosResponse<T_2, any>>(): Promise<R_1>;
        register<T_3 = any, R_2 = AxiosResponse<T_3, any>>(values: {
            [key: string]: any;
            email: string;
            emailConfirmation: string;
            password: any;
            passwordConfirmation: any;
            remember?: boolean | undefined;
        }): Promise<R_2>;
        requestPasswordReset<T_4 = any, R_3 = AxiosResponse<T_4, any>>(email: string): Promise<R_3>;
        resetPassword<T_5 = any, R_4 = AxiosResponse<T_5, any>>(values: {
            email: string;
            token: string;
            password: any;
            passwordConfirmation: any;
        }): Promise<R_4>;
    };
} & T;
//# sourceMappingURL=auth.d.ts.map