"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthMixin = void 0;
// eslint-disable-next-line @typescript-eslint/explicit-function-return-type
function AuthMixin(superClass) {
    return class extends superClass {
        login(values) {
            return __awaiter(this, void 0, void 0, function* () {
                const { remember = true } = values;
                const data = { remember, email: values.email, password: values.password };
                return this.post('login', { data });
            });
        }
        logout() {
            return __awaiter(this, void 0, void 0, function* () {
                return this.post('logout');
            });
        }
        register(values) {
            return __awaiter(this, void 0, void 0, function* () {
                const { emailConfirmation, passwordConfirmation, remember = true } = values, inputs = __rest(values, ["emailConfirmation", "passwordConfirmation", "remember"]);
                const data = Object.assign(Object.assign({}, inputs), { email_confirmation: emailConfirmation, password_confirmation: passwordConfirmation, remember });
                return this.post('register', { data });
            });
        }
        requestPasswordReset(email) {
            return __awaiter(this, void 0, void 0, function* () {
                return this.post('password/email', { data: { email } });
            });
        }
        resetPassword(values) {
            return __awaiter(this, void 0, void 0, function* () {
                const data = {
                    email: values.email,
                    token: values.token,
                    password: values.password,
                    password_confirmation: values.passwordConfirmation,
                };
                return this.post('password/reset', { data });
            });
        }
    };
}
exports.AuthMixin = AuthMixin;
//# sourceMappingURL=auth.js.map