"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AxiosErrorMixin = void 0;
const axios_1 = __importStar(require("axios"));
const helpers_1 = require("../helpers");
const helpers_2 = require("./helpers");
// eslint-disable-next-line @typescript-eslint/explicit-function-return-type
function AxiosErrorMixin(superClass) {
    return class extends superClass {
        get defaultErrorMessage() {
            return helpers_2.defaultErrorMessage;
        }
        errorsBlock(message) {
            return (0, helpers_2.errorsBlock)(message);
        }
        handleError(error) {
            var _a, _b, _c, _d, _e, _f, _g, _h;
            let message = this.defaultErrorMessage;
            if (!axios_1.default.isAxiosError(error)) {
                const axiosErr = new axios_1.AxiosError(error === null || error === void 0 ? void 0 : error.message);
                axiosErr.response = {
                    headers: {},
                    config: {},
                    status: 500,
                    statusText: 'Internal Server Error',
                    data: {
                        message,
                        errors: this.errorsBlock(message),
                    },
                };
                throw axiosErr;
            }
            const { errors, message: responseMessage } = (0, helpers_1.safeResponseData)(error.response);
            if (typeof responseMessage === 'string') {
                message = responseMessage;
            }
            if (!error.message) {
                error.message = message;
            }
            if (errors && typeof errors === 'object') {
                throw error;
            }
            error.response = {
                headers: (_b = (_a = error === null || error === void 0 ? void 0 : error.response) === null || _a === void 0 ? void 0 : _a.headers) !== null && _b !== void 0 ? _b : {},
                config: (_c = error === null || error === void 0 ? void 0 : error.config) !== null && _c !== void 0 ? _c : (_d = error === null || error === void 0 ? void 0 : error.response) === null || _d === void 0 ? void 0 : _d.config,
                status: (_f = (_e = error === null || error === void 0 ? void 0 : error.response) === null || _e === void 0 ? void 0 : _e.status) !== null && _f !== void 0 ? _f : 500,
                statusText: (_h = (_g = error === null || error === void 0 ? void 0 : error.response) === null || _g === void 0 ? void 0 : _g.statusText) !== null && _h !== void 0 ? _h : 'Internal Server Error',
                data: {
                    message,
                    errors: this.errorsBlock(message),
                },
            };
            throw error;
        }
    };
}
exports.AxiosErrorMixin = AxiosErrorMixin;
//# sourceMappingURL=axiosError.js.map