"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormMixin = void 0;
const qs_1 = __importDefault(require("qs"));
// eslint-disable-next-line @typescript-eslint/explicit-function-return-type
function FormMixin(superClass) {
    return class extends superClass {
        constructor() {
            super(...arguments);
            /** @protected */
            this.shouldStringify = true;
        }
        // Always set Content-Type to application/x-www-form-urlencoded, place in assign last.
        get config() {
            return Object.assign(Object.assign({}, super.config), { headers: Object.assign({ 'Content-Type': 'application/x-www-form-urlencoded', Accept: 'application/json' }, super.config.headers) });
        }
        preventStringify() {
            this.shouldStringify = false;
        }
        requestConfig(requestConfig) {
            const config = super.requestConfig(requestConfig);
            if (!config.data || typeof config.data !== 'object') {
                return config;
            }
            if (this.shouldStringify && !(config.data instanceof FormData)) {
                config.data = qs_1.default.stringify(config.data);
            }
            return config;
        }
    };
}
exports.FormMixin = FormMixin;
//# sourceMappingURL=form.js.map