"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HandleErrorMixin = void 0;
const helpers_1 = require("./helpers");
// eslint-disable-next-line @typescript-eslint/explicit-function-return-type
function HandleErrorMixin(superClass) {
    return class extends superClass {
        constructor() {
            super(...arguments);
            /** @protected */
            this.shouldThrowError = false;
        }
        throwResponseError() {
            this.shouldThrowError = true;
        }
        get defaultErrorMessage() {
            return helpers_1.defaultErrorMessage;
        }
        errorsBlock(message) {
            return (0, helpers_1.errorsBlock)(message);
        }
        handleError(error) {
            var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
            if (this.shouldThrowError) {
                throw error;
            }
            let message = this.defaultErrorMessage;
            if ((_b = (_a = error === null || error === void 0 ? void 0 : error.response) === null || _a === void 0 ? void 0 : _a.data) === null || _b === void 0 ? void 0 : _b.errors) {
                return error.response;
            }
            else if (typeof ((_d = (_c = error === null || error === void 0 ? void 0 : error.response) === null || _c === void 0 ? void 0 : _c.data) === null || _d === void 0 ? void 0 : _d.message) === 'string') {
                message = error.response.data.message;
            }
            return {
                headers: (_e = error === null || error === void 0 ? void 0 : error.response) === null || _e === void 0 ? void 0 : _e.headers,
                config: (_f = error === null || error === void 0 ? void 0 : error.config) !== null && _f !== void 0 ? _f : (_g = error === null || error === void 0 ? void 0 : error.response) === null || _g === void 0 ? void 0 : _g.config,
                status: (_j = (_h = error === null || error === void 0 ? void 0 : error.response) === null || _h === void 0 ? void 0 : _h.status) !== null && _j !== void 0 ? _j : 500,
                statusText: (_l = (_k = error === null || error === void 0 ? void 0 : error.response) === null || _k === void 0 ? void 0 : _k.statusText) !== null && _l !== void 0 ? _l : 'Internal Server Error',
                data: {
                    message,
                    errors: this.errorsBlock(message),
                },
            };
        }
    };
}
exports.HandleErrorMixin = HandleErrorMixin;
//# sourceMappingURL=handleError.js.map