import { AxiosRequestConfig, AxiosResponse } from 'axios';
import { Constructor } from './types';
export declare function SessionCsrfCookieMixin<C extends Constructor<any>>(superClass: C): {
    new (...args: any[]): {
        [x: string]: any;
        /**
         * Used to tell if a csrf cookie fix request is happening.
         * Otherwise we'd have an infinite loop. This also ensures
         * we only retry once.
         *
         * @type {boolean}
         * @protected
         */
        csrfCookieFix: boolean;
        isCsrfTokenMismatch<T = any>(response: AxiosResponse<T, any>): boolean;
        readonly csrfPath: string;
        requestCsrfCookie(): Promise<any>;
        request<T_1 = any, R = AxiosResponse<T_1, any>>(requestConfig: AxiosRequestConfig): Promise<R>;
    };
} & C;
//# sourceMappingURL=sessionCsrfCookie.d.ts.map