"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserMixin = void 0;
// eslint-disable-next-line @typescript-eslint/explicit-function-return-type
function UserMixin(superClass) {
    return class extends superClass {
        current() {
            return __awaiter(this, void 0, void 0, function* () {
                return this.get('user');
            });
        }
        show(userId, params) {
            return __awaiter(this, void 0, void 0, function* () {
                return this.get(`user/${userId}`, { params });
            });
        }
        update(userId, data) {
            return __awaiter(this, void 0, void 0, function* () {
                return this.put(`user/${userId}`, { data });
            });
        }
        resendEmailVerification() {
            return __awaiter(this, void 0, void 0, function* () {
                return this.post('email/resend');
            });
        }
        changePassword(values) {
            return __awaiter(this, void 0, void 0, function* () {
                const data = {
                    password: values.password,
                    current_password: values.currentPassword,
                    password_confirmation: values.passwordConfirmation,
                };
                return this.put('password/change', { data });
            });
        }
        confirmPassword(password) {
            return __awaiter(this, void 0, void 0, function* () {
                return this.post('password/confirm', { data: { password } });
            });
        }
    };
}
exports.UserMixin = UserMixin;
//# sourceMappingURL=user.js.map