"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.setGlobalOptions = exports.globalOptions = exports.Options = void 0;
const axios_1 = __importDefault(require("axios"));
class Options {
    constructor(options) {
        var _a, _b, _c;
        this._path = '';
        this._axios = axios_1.default;
        /* istanbul ignore next */
        this._origin = (typeof window !== 'undefined' && window.location && window.location.origin) || '';
        this.axios = (_a = options === null || options === void 0 ? void 0 : options.axios) !== null && _a !== void 0 ? _a : this.axios;
        this.origin = (_b = options === null || options === void 0 ? void 0 : options.origin) !== null && _b !== void 0 ? _b : this.origin;
        this.path = (_c = options === null || options === void 0 ? void 0 : options.path) !== null && _c !== void 0 ? _c : this.path;
        if (typeof (options === null || options === void 0 ? void 0 : options.withCredentials) === 'boolean') {
            this.withCredentials = options.withCredentials;
        }
    }
    get axios() {
        return this._axios;
    }
    set axios(axios) {
        this._axios = axios;
    }
    get origin() {
        return this._origin;
    }
    set origin(origin) {
        this._origin = origin;
    }
    get path() {
        return this._path;
    }
    set path(path) {
        this._path = path;
    }
    get withCredentials() {
        return this._axios.defaults.withCredentials;
    }
    set withCredentials(withCredentials) {
        this._axios.defaults.withCredentials = withCredentials;
    }
}
exports.Options = Options;
let globalOptions = new Options();
exports.globalOptions = globalOptions;
function setGlobalOptions(options) {
    exports.globalOptions = globalOptions = options;
}
exports.setGlobalOptions = setGlobalOptions;
//# sourceMappingURL=options.js.map